<?php
require "class.calendar.inc.php";

class linkcalendar extends calendar {

	var $cal_hilite_date_list;
	
	function linkcalendar( $date , $tempalate , $stylesheet , $stylesheet_prefix , $list_of_dates){
		parent::calendar( $date, $tempalate, $stylesheet, $stylesheet_prefix );
		$this->cal_hilite_date_list = $list_of_dates;
	}
	
	function showmonth(){
		$this->cal_wrk_tmp = $this->exrt_nd_temp_frm_mtemp ('<!-- BEGIN Calendar_Month_Type -->','<!-- END Calendar_Month_Type -->');
		$this->rp_cal_wrk_tmp('{C_STYLESHEET_C}',$this->cal_ssht,'','1');
		$this->rp_cal_wrk_tmp('{C_CSS_CALENDAR_BOX_C}',$this->cal_ssht_pfx.'-cal-box','','1');
		$this->rp_cal_wrk_tmp('{C_CSS_CALENDAR_BACK_C}',$this->cal_ssht_pfx.'-cal-back','','1');
		$this->rp_cal_wrk_tmp('{C_CSS_CALENDAR_YEAR_BOX_C}',$this->cal_ssht_pfx.'-cal-year-box','','1');
		$this->rp_cal_wrk_tmp('{C_CSS_CALENDAR_YEAR_PREVIOUS_BUTTON_C}',$this->cal_ssht_pfx.'-cal-year-prev','','1');
		$this->rp_cal_wrk_tmp('{C_CSS_CALENDAR_YEAR_TEXT_C}',$this->cal_ssht_pfx.'-cal-year','','1');
		$this->rp_cal_wrk_tmp('{C_CSS_CALENDAR_YEAR_NEXT_BUTTON_C}',$this->cal_ssht_pfx.'-cal-year-next','','1');
		$this->rp_cal_wrk_tmp('{C_CSS_CALENDAR_MONTH_BOX_C}',$this->cal_ssht_pfx.'-cal-month-box','','1');
		$this->rp_cal_wrk_tmp('{C_CSS_CALENDAR_MONTH_PREVIOUS_BUTTON_C}',$this->cal_ssht_pfx.'-cal-month-prev','','1');
		$this->rp_cal_wrk_tmp('{C_CSS_CALENDAR_MONTH_TEXT_C}',$this->cal_ssht_pfx.'-cal-month','','1');
		$this->rp_cal_wrk_tmp('{C_CSS_CALENDAR_MONTH_NEXT_BUTTON_C}',$this->cal_ssht_pfx.'-cal-month-next','','1');
		$this->rp_cal_wrk_tmp('{C_CSS_CALENDAR_DAYS_OF_WEEK_BOX_C}',$this->cal_ssht_pfx.'-cal-days-box','','1');
		$this->rp_cal_wrk_tmp('{C_CSS_DAYS_OF_WEEK_START_C}',$this->cal_ssht_pfx.'-cal-day-start','','1');
		$this->rp_cal_wrk_tmp('{C_CSS_DAYS_OF_WEEK_REST_C}',$this->cal_ssht_pfx.'-cal-day-rest','','1');
		$this->rp_cal_wrk_tmp('{C_CAL_HEIGHT_C}',(string)$this->cal_t_ht,'','1');
		$this->rp_cal_wrk_tmp('{C_CAL_WIDTH_C}',(string)$this->cal_t_wt,'','1');
		$temp_calendar_row_height = (string)(round($this->cal_t_ht / 9));
		$this->rp_cal_wrk_tmp('{C_CAL_ROW_HEIGHT_C}',$temp_calendar_row_height,'','1');

		// Generate For Year 
		$this->rp_cal_wrk_tmp('{C_YEAR_PREV_C}','<<',$this->gen_cal_lnk($this->get_yr_prev($this->cal_s_date)),'1');
		$this->rp_cal_wrk_tmp('{C_YEAR_C}',$this->get_year($this->cal_s_date,'1'),'','1');
		$this->rp_cal_wrk_tmp('{C_YEAR_NEXT_C}','>>',$this->gen_cal_lnk($this->get_yr_nxt($this->cal_s_date)),'1');
		
		//Generete for Month
		$this->rp_cal_wrk_tmp('{C_MONTH_PREV_C}','<<',$this->gen_cal_lnk($this->get_mnt_prev($this->cal_s_date)),'1');
		$this->rp_cal_wrk_tmp('{C_MONTH_C}',$this->get_month($this->cal_s_date,'1'),'','1');
		$this->rp_cal_wrk_tmp('{C_MONTH_NEXT_C}','>>',$this->gen_cal_lnk($this->get_mnt_nxt($this->cal_s_date)),'1');
		
		//Generate Days
		//start day = location of the given month in 0 to 365 - start of the week of the month + 1
		$start_day= $this->get_mnt_strt_loc_in_yr($this->cal_s_date) - $this->get_mnt_strt_day($this->cal_s_date,'1') + 1 ;
		$day_of_month = 0;
		for($current_row=1;$current_row<=6;$current_row++){
			for($current_column=1;$current_column<=7;$current_column++){
				$srch_str='{C_DAY_MATRIX_'.$current_row.'X'.$current_column.'_C}';
				$srch_css_str='{C_CSS_DAY_MATRIX_'.$current_row.'X'.$current_column.'_C}';
				$gen_date=$this->get_date_frm_loc_in_yr($start_day,$this->cal_s_date);
				$rep_str=$this->get_day($gen_date,'1');
				$start_day++;
				$is_link_date = $this->is_link_date($this->get_day(++$day_of_month,'1'));								// added AUG-10-2004 geoff@hoffmans.net
				if ($is_link_date){																						// added AUG-10-2004 geoff@hoffmans.net
					$this->rp_cal_wrk_tmp($srch_str,$rep_str,$this->gen_cal_lnk($gen_date,NULL,$is_link_date),'1');} 	// added AUG-10-2004 geoff@hoffmans.net
				elseif ($this->get_month($this->cal_s_date,'4')==$this->get_month($gen_date,'4')){
					$this->rp_cal_wrk_tmp($srch_str,$rep_str,$this->gen_cal_lnk($gen_date),'1');}
				else{
					$this->rp_cal_wrk_tmp($srch_str,$rep_str,$this->gen_cal_lnk($gen_date),'2');}
				if($this->get_today_date()==$gen_date){
					$this->rp_cal_wrk_tmp($srch_css_str,$this->cal_ssht_pfx.'-cal-cur-day','','1');}
				elseif ($gen_date==$this->cal_s_date){
					$this->rp_cal_wrk_tmp($srch_css_str,$this->cal_ssht_pfx.'-cal-sel-day','','1');}
				elseif ($current_column==1 && !$is_link_date){
					$this->rp_cal_wrk_tmp($srch_css_str,$this->cal_ssht_pfx.'-cal-days-start','','1');}
				// insert your custom date link CSS here 																// added AUG-10-2004 geoff@hoffmans.net
				elseif ($this->is_link_date($rep_str)){ 																// added AUG-10-2004 geoff@hoffmans.net
					$this->rp_cal_wrk_tmp($srch_css_str,$this->cal_ssht_pfx.'-cal-link-day','','1');}   				// added AUG-10-2004 geoff@hoffmans.net
				else{
					$this->rp_cal_wrk_tmp($srch_css_str,$this->cal_ssht_pfx.'-cal-days-rest','','1');}
		}	}
		print $this->cal_wrk_tmp;
	}
	
	// added AUG-10-2004 geoff@hoffmans.net
	// returns the current month being displayed by the cal in '03' format
	function get_cal_month( ){
		return $this->get_month($this->cal_s_date,'3');
	}
	
	// added AUG-10-2004 geoff@hoffmans.net
	// returns the current year being displayed by the cal in '2004' format
	function get_cal_year( ){
		return $this->get_year($this->cal_s_date,'1');
	}
	
	function is_link_date( $dn ){
		$match = $this->cal_hilite_date_list[$this->get_cal_month()."-".$dn."-".$this->get_cal_year()];
		if($match){
			return $match;
		}else{
			return false;
		}
	}
}

?>